unit HostGame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, WindowsUtils,
  Constants;

type
  TFrmHostGame = class(TForm)
    BtnOK: TButton;
    txtNickname: TEdit;
    lblNickname: TLabel;
    txtSlots: TEdit;
    lblInitialMoney: TLabel;
    txtInitialMoney: TEdit;
    lblSlots: TLabel;
    lblCip: TLabel;
    txtCip: TEdit;
    txtPort: TEdit;
    lblPort: TLabel;
    lblPassword: TLabel;
    txtPassword: TEdit;
    txtTableName: TEdit;
    lblTableName: TLabel;
    udSlots: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure txtNicknameChange(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
  private
    procedure SetDefaultServerName;
  public
    { Public declarations }
  end;

var
  FrmHostGame: TFrmHostGame;

implementation

{$R *.dfm}

procedure TFrmHostGame.FormCreate(Sender: TObject);
begin
  { Assegna alla Textbox con il nickname l'utente di windows attivo }
  txtNickname.Text := GetLoginName;

  { Assegna il valore di default al nome del server }
  SetDefaultServerName;
  txtPort.Text := IntToStr(DEFAULTPORT);

  BtnOK.Caption := '&Avvia la partita';
end;

{ Procedura per impostare un valore di default al nome del server
(in base al nickname) }
procedure TFrmHostGame.SetDefaultServerName;
begin
  txtTableName.Text := txtNickname.Text + '''s game';
end;

procedure TFrmHostGame.txtNicknameChange(Sender: TObject);
begin
  { Refresha il nome del server in automatico }
  if txtNickname.Text <> '' then SetDefaultServerName
  else txtTableName.Text := 'game';
end;

procedure TFrmHostGame.BtnOKClick(Sender: TObject);
begin
  self.ModalResult := mrOk;
end;

end.
